Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time

From: Jean Louis <[email-masked]>
Date: Thu, 26 Nov 2020 21:37:56 +0300

* Eli Zaretskii <[email-masked]> [2020-11-26 17:14]:
> > Date: Thu, 26 Nov 2020 12:09:32 +0300
> > From: Jean Louis <[email-masked]>
> > Cc: Carlos O'Donell <[email-masked]>, [email-masked],
> >   [email-masked], [email-masked], [email-masked],
> >   [email-masked]
> > 
> > ((uptime "2 days, 18 hours, 35 minutes, 19 seconds") (pid 13339) (garbage ((conses 16 4511014 617524) (symbols 48 86926 23) (strings 32 576134 114546) (string-bytes 1 25198549) (vectors 16 245670) (vector-slots 8 4636183 1560354) (floats 8 1859 18842) (intervals 56 655325 24178) (buffers 992 900))) (buffers-size 200898858) (vsize (vsize 5144252)))
> > 
> > But what happened after 36 minutes of waiting is that Emacs became
> > responsive. So I am still running this session and I hope to get
> > mtrace after the session has finished.
> > 
> > Before I was not patient longer than maybe 3-5 minutes and I have
> > aborted Emacs. But now I can see it stabilized after hard work with
> > memory or whatever it was doing. Swap is 1809 MB and vsize just same
> > as above.
> 
> It's still 5GB, which is a fairly large footprint, certainly for a
> 2-day session.

And this time I could observe it was quick to reach, like from some
200 MB swap reported it grew to few gigabytes in few minutes.

> > Observation on "what I was doing when vsize started growing" is
> > simple, I was just editing email, nothing drastic. I did not do
> > anything special.
> 
> Can you describe in more detail how you edit email?  Which email
> package(s) do you do, and what would composing email generally
> involve?

I was using XTerm invoked from outside with mutt. Mutt invokes
emacsclient and it uses normally same frame, but sometimes other
frame. Default setting is to use new frame, but I sometimes change to
invoke it without creating new frame.

There are 2 modules vterm that I load and emacs-libpq for database.

> Also, are there any background activities that routinely run in your
> Emacs sessions?

Jabber doing XMPP without problem before, persistent scratch,
symon-mode, helm, sql-postgres mode, there is eshell always invoked
and shell.

Timers now:
               5.0s            - undo-auto--boundary-timer
              10.1s        30.0s jabber-whitespace-ping-do
              18.8s      1m 0.0s display-time-event-handler
           4m 49.4s      5m 0.0s persistent-scratch-save
          31m 10.9s   1h 0m 0.0s url-cookie-write-file
   *           0.1s            t show-paren-function
   *           0.5s      :repeat blink-cursor-start
   *           0.5s            t #f(compiled-function () #<bytecode 0x23a02dfeda0a1d> [jit-lock--antiblink-grace-timer jit-lock-context-fontify])
   *           1.0s            - helm-ff--cache-mode-refresh
   *           2.0s            t jabber-activity-clean

> > If you say I should finish session now and send the mtrace, I can do
> > it.
> 
> That's for Carlos to say.
> 
> Thanks for the info.

That session after some time invoked much harder hard disk swapping
and I have killed Emacs. But I could not find mtrace with
corresponding PID for that Emacs session

For this session I can see the corresponding PID on the disk. I am now
at 8 hours session. Once finishes I hope that mtrace file will not be
deleted even if I kill Emacs.

((uptime "8 hours, 8 minutes, 11 seconds") (pid 7385) (garbage ((conses 16 1032190 170175) (symbols 48 49048 11) (strings 32 252789 45307) (string-bytes 1 8153413) (vectors 16 84232) (vector-slots 8 1713735 81778) (floats 8 690 1822) (intervals 56 68015 4240) (buffers 984 105))) (buffers-size 3632683) (vsize (vsize 1217088)))